您的位置:首页 > 其它

HDU 4745 Two Rabbits(区间DP,最长非连续回文子串)

2016-03-17 10:57 459 查看
Two Rabbits

Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65535/65535 K (Java/Others)

Total Submission(s): 1274 Accepted Submission(s): 641

Problem Description

Long long ago, there lived two rabbits Tom and Jerry in the forest. On a sunny afternoon, they planned to play a game with some stones. There were n stones on the ground and they were arranged as a clockwise ring. That is to say, the first stone was adjacent to the second stone and the n-th stone, and the second stone is adjacent to the first stone and the third stone, and so on. The weight of the i-th stone is ai.

The rabbits jumped from one stone to another. Tom always jumped clockwise, and Jerry always jumped anticlockwise.

At the beginning, the rabbits both choose a stone and stand on it. Then at each turn, Tom should choose a stone which have not been stepped by itself and then jumped to it, and Jerry should do the same thing as Tom, but the jumping direction is anti-clockwise.

For some unknown reason, at any time , the weight of the two stones on which the two rabbits stood should be equal. Besides, any rabbit couldn’t jump over a stone which have been stepped by itself. In other words, if the Tom had stood on the second stone, it cannot jump from the first stone to the third stone or from the n-the stone to the 4-th stone.

Please note that during the whole process, it was OK for the two rabbits to stand on a same stone at the same time.

Now they want to find out the maximum turns they can play if they follow the optimal strategy.

Input

The input contains at most 20 test cases.

For each test cases, the first line contains a integer n denoting the number of stones.

The next line contains n integers separated by space, and the i-th integer ai denotes the weight of the i-th stone.(1 <= n <= 1000, 1 <= ai <= 1000)

The input ends with n = 0.

Output

For each test case, print a integer denoting the maximum turns.

Sample Input

1

1

4

1 1 2 1

6

2 1 1 2 1 3

0

Sample Output

1

4

5

Hint

For the second case, the path of the Tom is 1, 2, 3, 4, and the path of Jerry is 1, 4, 3, 2.

For the third case, the path of Tom is 1,2,3,4,5 and the path of Jerry is 4,3,2,1,5.

这道题大意就是求最长非连续回文子串,但是序列是连续的形成环的,同常的做法是倍增,然后求长度限制为n的区间的最长回文串。但是倍增要注意,如果两只兔子站在同一个起点上,那么就有长度n-1区间的回文串长度加1,当然起点是n-1区间之外的点,所以结果应该在dp(n),和dp(n-1)+1之间比较。

网上看到还有一种解法不用倍增,直接当成链,然后分割链,两条链的和就是最优解,

关于区间DP,可以参照这个博客

/article/9576461.html

#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <math.h>
#include <stdio.h>

using namespace std;
int a[2005];
int dp[2005][2005];
int n;
int main()
{
int t;

while(scanf("%d",&n)!=EOF)
{
if(n==0)
break;
for(int i=1;i<=n;i++)
{
scanf("%d",&a[i]);
a[i+n]=a[i];
}
memset(dp,0,sizeof(dp));
for(int i=1;i<=2*n;i++)
dp[i][i]=1;
for(int l=1;l<=2*n;l++)
{
for(int i=1;i+l<=2*n;i++)
{
int j=i+l;
dp[i][j]=max(dp[i+1][j],max(dp[i][j-1],(a[i]==a[j]?dp[i+1][j-1]+2:dp[i+1][j-1])));

}
}
int ans=0;
for(int i=1;i<=n;i++)
ans=max(ans,dp[i][i+n-1]);
for(int i=1;i<=n;i++)
ans=max(ans,dp[i][i+n-2]+1);
printf("%d\n",ans);
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: